$ ! Apache:Makefile_OpenVMS.Com
$ ! START HERE!! Use this file to install or build Apache on OpenVMS
$ ! @makefile_openvms HELP for description of where OpeVMS specific 
$ ! files are placed..
$ !
$ !
$ ! Usage:
$ !   @makefile_openvms HELP
$ !   @makefile_openvms INSTALL
$ !   @makefile_openvms BUILD	! DEBUG is optional second parameter
$ !   @makefile_openvms LINK	! DEBUG is optional second parameter
$ !   @makefile_openvms CLEANUP	! Remove extraneous files after a build.
$ !
$ ! 
$ !___________________________________________________________________________
$
$ set :=
$ set symbol/scope=(nolocal,noglobal)
$
$ pass_p1s := /INSTALL/BUILD/LINK/CLEANUP/
$
$
$ if "''P1'" .eqs. "" -
    .or. f$locate("/''P1'/", pass_p1s) .eq. f$length(pass_p1s)
$ then
$   gosub Usage
$   exit
$ endif
$
$
$ start_time = f$extract(0, 20, f$time())
$ write sys$output f$fao("!/!AS!/", "Starting Apache ''P1' at ''start_time'")
$
$
$ gosub Define_Apache_Install
$ on warning then $goto done
$
$ if "''P1'" .eqs. "INSTALL"
$ then
$   gosub Install_Apache
$ else
$   save_verify = f$verify(0)
$
$   ! Use the Define=VMS here rather than using the __VMS provided by DECC does
$   ! two things. The better reason is to fit in with the Apache scheme of
$   ! macros for operating systems.  Secondarily, it reduces the dependence
$   ! on DEC C (for which I have freely introduced many dependencies).
$  
$   apache_cc_defines := /Define=(VMS=1)
$
$   link_opt_trnlnm = f$trnlnm("apache_link_options")
$   if "''P2'" .eqs "DEBUG"
$   then
$     define apache_cc_options "/Debug/NoOpt ''apache_cc_defines'"
$     define apache_link_options "/Debug"
$   else
$     if f$getsyi("ARCH_NAME") .nes. "VAX" 
$     then
$	arch_type := Generic ! use most general value for kit build
$
$	! If your are building on site for the machine on which Apache will run
$	! you may want to uncomment the next line to take advantage of compiler
$	! architecture specific optimizations.
$	! arch_type := Host
$ 
$	cc_opts =  f$fao("!AS !AS!AS", -
		"/Arch=''arch_type'", -
		"/mms=nosystem",-
		"/Optimize=(Level=6, Inline=Speed, Tune=''arch_type')")
$     endif
$
$     define apache_cc_options "''cc_opts'/Machine 'apache_cc_defines"
$     if link_opt_trnlnm .eqs. "" then -
		define apache_link_options "/NoDebug/NoTraceback"
$   endif
$ 
$   @apache_install:[src.os.openvms]makefile_src -
			"''P1'" "''P2'" -
			"''P3'" "''P4'" -
			"''P5'" "''P6'" -
			"''P7'" "''P8'"
$
$   deassign APACHE_CC_OPTIONS
$   if link_opt_trnlnm .eqs. "" then deassign APACHE_LINK_OPTIONS
$ endif
$
$ deassign APACHE_INSTALL
$
$ discard = f$verify('save_verify')
$
$ write sys$output f$fao("!/!AS", "Successful Apache ''P1'")
$
$ Done:
$  save_verify = f$verify('save_verify') ! In case we got here by error.
$
$  write sys$output "        done    at ", f$extract(0, 20, f$time())
$  write sys$output "        started at ''start_time'"
$  EXIT
$
$ !___________________________________________________________________________
$ !___________________________________________________________________________
$ Define_Apache_Install:
$ ! Find the top directory in this tree. Deek around concealed logical names.
$
$ ! This parse may not work with excessively clever and/or ODS-5 directory 
$ ! names.
$
$   this_proc = f$env("PROCEDURE")
$   this_dev = f$parse(this_proc,,, "DEVICE", "NO_CONCEAL, SYNTAX_ONLY")
$   this_dir = f$parse(this_proc,,, "DIRECTORY", "NO_CONCEAL, SYNTAX_ONLY")
$   root = this_dev + this_dir - "][" - "]<" - ">[" - "><"
$   root = f$extract(0,f$locate(".SRC",f$edit(root,"UPCASE")),root)
$   
$   if f$extract(0, 1, this_dir) .eqs. "["
$   then 
$	root = root + ".]"
$   else
$	root = root + ".>"
$   endif
$   rlen = f$length(root)
$   root2 = f$extract(0,rlen-4,root) + f$extract(rlen-2,2,root)
$
$   define APACHE_BASE "''root2'"/trans=(termin,conceal)
$   define APACHE_INSTALL "''root'"/trans=(term,conceal),APACHE_BASE:
$   sho logical APACHE_INSTALL
$ return
$ !___________________________________________________________________________
$ Install_Apache:
$  
$  from := APACHE_INSTALL:[SRC.OS.OPENVMS]
$  exes := 'from'*.EXE_*;
$
$  save_verify = f$verify(1)
$
$  if f$search("''exes'") .nes. ""
$  then
$    backup/log/new 'exes' -
		    APACHE_INSTALL:[000000]
$  else
$    quiet = f$verify('save_verify')
$    copy sys$input: sys$output:
$    deck

    No executable images in this kit. One must compile and link
    architecture (Alpha, VAX) specific images. A DEC C compiler
    is necessary.

    @makefile_openvms BUILD	! DEBUG is optional second parameter
	

    Images are left in [APACHE.SRC] and need to be manually moved
    to [APACHE] (assuming [APACHE] is top level directory of the
    tree which contains this file.

$    eod
$    save_verify = f$verify(1)
$  endif
$
$  backup/log/new   'from'LOGIN.COM;, -
		    'from'APACHE_HTTPD_RUN.COM;, -
		    'from'APACHE_SETUP.COM;, -
		    'from'APACHE_STARTUP.COM; -
		    APACHE_INSTALL:[000000]
$
$
$   quiet = f$verify('save_verify')
$
$   copy sys$input: sys$output:
$   deck

    See readme.openvms for additional installation steps.

$    eod
$
$ return
$ !___________________________________________________________________________
$ Usage:
$ ! Print usage message to SYS$OUTPUT:, give folks a sporting chance.
$ ! Yeah, I know, it is more than 24 lines.
$
$ copy sys$input: sys$output:
$ deck

Usage:

    @makefile_openvms
    @makefile_openvms HELP

	Print this message

    @makefile_openvms INSTALL

	Move the OpenVMS specific files into the top level directory
	of the tree which contains this file. E.g. from 
	disk1:[APACHE.SRC.OS.OPENVMS] to disk1:[APACHE]

  Advanced:

    @makefile_openvms BUILD	! DEBUG is optional second parameter
	
	Compile and link architecture (Alpha, VAX) specific images.

    @makefile_openvms LINK	! DEBUG is optional second parameter

	Link architecture (Alpha, VAX) specific images.

    Images are left in [APACHE.SRC] and need to be manually moved
    to [APACHE] (assuming [APACHE] is top level directory of the
    tree which contains this file.

$  eod
$ return
$ !___________________________________________________________________________
$
$ ! End of file
